;*****************************************
;Plugin_Koda_Convert.au3 by SirWayNe
;Erstellt mit ISN AutoIt Studio v. 0.96 BETA
;*****************************************


#cs	To Do List
-> Aufflligkeiten mit falschen XML Dateien, es werden keine Werte ausgelesen.
	<property name="Resizing" vt="Set"/>
-> ISF scheint guiCtrlSetResizing nichz zu untersttzen?
	-> Konverter wird Extra Code einfgen
-> Font wird in der GUI Ebene nicht untersttzt
-> _KodaGetHexColor nimmt die Farben aus dem aktuellen System. Eventuell die Funktion als bgcolor abspeichern (siehe Forum)
	-> Eventuell neue Variable mit IncludeUseWINAPI und weitere
-> Control an Position locken wird nicht untersttzt
-> CtrlState wird nicht von KODA untersttzt
	-> es wird das Default von ISF gesetzt
-> Manche Styles werden in KODA automatisch gesetzt, diese mssen fr das ISF entfernt werden. Es kommt ansonsten zu Darstellungsfehlern
-> ISF scheint kein AVI zu untersttzen?
-> FontWeight wird benutzt um Attr Fett darzustellen
-> Wenn ein TAB keine Pages (mehr) enthlt, kann man auch keine pages mehr hinzufgen
-> Explorer Verknpfung mit ISF erstellen
-> Include Once fehlt beim ISF2 mit passenden Includes, wenn Funktionen und Vars verwendet werden.
-> Die Positionierung der Controls innerhalb der TABS sind absolut zum GUI und nicht relativ zum TAB (wie in KODA)
	-> Daher rechnet der Converter die Pos des Controls wie folgt:
		-> Pos Tab + Pos Control + Fontsize(Tab)
-> ParentFont nicht bentigt von ISF, bedeutet, dass das Control nicht das Font des MAIN benutzt
-> Code wird von KODA nicht gesttzt
-> BGimage im GUI wird nicht von KODA untersttzt
-> Die Untersttzung von Menues ist auf 50.000 Zeichen begrenzt
-> Menu Enable wird von KODA untersttzt, nicht von ISN
-> Koda untersttzt keine Menu Icons
-> ISN Untersttzt keine Hotkeys in Menues (GuiSetAccelerator)
-> Ampersend wird in KODA fr das menu verwendet, wird so nicht in ISF utnersttzt.
-> Das Plugin bentigt ein GUI, damit das ISN erkennt, dass das Plugin luft.
-> Manche MsgBoxen bekommen keinen Focus wenn z.B. das ISF im ISN aktiv ist
	-> Programm sieht abgest+tzt aus, die Boxen bekommen nur keinen Focus

-> Styles fehlen im ISF:
	Buttons:
		$BS_PUSHBOX
		$BS_PUSHLIKE
	CheckBox:
		$BS_CHECKBOX
		$BS_AUTOCHECKBOX
	ComboBox
		$CBS_HASSTRINGS
		$CBS_OWNERDRAWFIXED
		$CBS_OWNERDRAWVARIABLE
	Date
		$DTS_SHORTDATECENTURYFORMAT
		$DTS_APPCANPARSE

To Do:
	-> Funktion KodaGetBool benutzen, um TRUE -> 1 und FALSE -> 0
		-> funktioniert das bei anderen Werten?
	-> Einstellungen fr Plugins sind ber das ISN nicht mglich
		-> Einstellungen ber die Plugin.ini merken
	-> Funktionen werden noch nicht untersttz.
	-> OnEvent Funktionen fehlen ebenfalls noch
		-> Funktionieren fr Controls	DONE
		-> Gui Fehlt noch
	-> $hScriptGui erstellt fr das GUI wenn als eigentstndiges Tool erstellt.
	Style Controls bersprungen:
		-> ContextMenu
	Date scheint nicht richtig von ISF untersttzt zu werden (styles)
	-> Date und time werden im Struct gesetzt, aber nicht verwendet
	Position GUI mssen noch angepasst werden. Nach KODA
	Coder Einstellung
	-> OnClose
	-> FormOptExpVars
	-> FormOptPopulate
	-> FormOptVarsForSet
	-> FormOptIndentChar
	-> FormOptIndentCount
	-> FormOptIndentInit
	-> PixelsPerInch
	
	-> Version berprfung fehlt noch (getestet mit V 1.04)
	_ISFWriteComponents()
	_KodaSetStruct -> berarbeiten, es fehlen teilweise noch eintrge auchg in kombination mit Controls
	_KodaGetCtrlStyle berarbeiten
	-> wenn die Controls kein FONT aufweisen, soll das ber das GUI genommen werden. -> geschiet automatisch
		-> VariableSetDefValStruct
#ce

#include <Array.au3>
#include <File.au3>
#include <String.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>

#include <WindowsConstants.au3>
#include <AVIConstants.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <DateTimeConstants.au3>

#include "Forms/_XMLDomWrapper.au3"
#include "Forms\Variables.au3"
#include "Forms\Koda_Functions.au3"
#include "Forms\ISF_Functions.au3"
#include "Forms\Plugin.au3"
#include "Forms\isnautoitstudio_plugin.au3"


;~ Opt("GuiCoordMode", 0)
Opt("GuiOnEventMode", 1)
Opt("TrayIconHide", 1)
Opt("GUIResizeMode", 802)
Opt("GUICloseOnESC", 0)
;~ Opt("MustDeclareVars",1)

_VariablesInit()
#include "Forms\Gui.isf"
#include "Forms\Log.au3"
#include "Forms\Setting.au3"



If $bScriptIsPlugin = 1 Then
	_Plugin_Init()
	If UBound($Cmdline) > 1 Then
		$sKodaPathFile = FileGetLongName($Cmdline[1])
		GUICtrlSetData($cLabelFile,$sKodaPathFile)
		GUICtrlSetState($cBoxOpenISF,IniRead($sSettingFile,$sSettingSection,$sSettingKeyOpenISF,0))
		Sleep(500)
		GUISetState(@SW_SHOW,$hScriptGui)
;~ 		_ConvertFile()
	EndIf
Else
	GUISetState(@SW_SHOW,$hScriptGui)
	_SelectKodaFile()
EndIf


While 1
	Sleep(100)
WEnd

Func _SelectKodaFile()
	If GUICtrlRead($cLabelFile) <> $sScriptLabelDummy Then
		If MsgBox(4+32+256,"Question....","Do you want to select a new Koda File?",0,$hScriptGui) = 7 Then Return
	EndIf
	Global $sKodaPathFile = FileOpenDialog("Open .kxf File","","Koda Files (*.kxf)",1+2)
	If @error or FileExists($sKodaPathFile) = 0 Then Return
	GUICtrlSetData($cLabelFile,$sKodaPathFile)
	GUICtrlSetState($cButtonOpenISF,$GUI_DISABLE)
EndFUnc

Func _ConvertAutoitFile()
	; Check Contents of Edit
	
	If _ISFCreateISFfile() = 1 Then Return
	
	
EndFunc

Func _ConvertKodaFile()
	$sKodaPathFile = GUICtrlRead($cLabelFile)
	If @error Or FileExists($sKodaPathFile) = 0 Then Return
	
	
	If _ISFCreateISFfile($sKodaPathFile) = 1 Then Return
	_LogAdd("Creating ISF File succesfull...")
	_ISFSetMain()
	_LogAdd("Gui Conversion succesfull...")
	_ISFSetComponents()
	_LogAdd("Guicontrols Conversion succesfull....")
	_LogAdd("Found " & $iKodaComponentsCount & " Control Components.")
	If GuiCtrlRead($cBoxOpenISF) = $GUI_CHECKED Then _Plugin_OpenISF()
	GUICtrlSetState($cButtonOpenISF,$GUI_ENABLE)
	_LogAdd()
;~ 	_ScriptExit()
EndFunc


Func _ScriptExit()
	If $bScriptIsPlugin = 1 Then
		_Plugin_Exit()
	EndIf
	Exit 
EndFunc

