;Koda_Functions.au3


Func _KodaReadFileToArray($file)
	$oXMLopen = _XMLFileOpen($file, " ")
	If @error Then Exit ConsoleWrite("Error FileOpen: " & _XMLError() & @LF)
	
	$aKodaGuiName = _XMLGetAllAttrib("object")
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
	$aKodaGuiAttributes = _XMLGetAllAttrib("object/properties/property");
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
	$aKodaGuiValues = _XMLGetValue("properties/property"); -> bekomme ich alle Werte aus den Properties gelesen
	If @error Then ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
	
	#cs
;~ 	$XMLcount = _XMLGetNodeCount($text)
;~ 	ConsoleWrite("Nodecount: " & $XMLcount & @TAB & "Error: " & @error & @LF)
;~ 	ConsoleWrite("Error GetNodeCount: " & _XMLError() & @LF)

;~ 	$array = _XMLSelectNodes($text)
;~ 	ConsoleWrite("Error SelectNode: " & _XMLError() & @LF)
;~ 	_ArrayDisplay($array, "1"); -> object

;~ 	$array = _XMLSelectNodes($text & "/" & $node)
;~ 	ConsoleWrite("Error SelectNode: " & _XMLError() & @LF)
;~ 	_ArrayDisplay($array, "3")

;~ 	$array = _XMLGetAllAttrib($text & "/" & $node, $a1, $a2)
;~ 	ConsoleWrite("Error GetValue: " & _XMLError() & @LF)
;~ 	_ArrayDisplay($array, "4")

;~ 	$array = _XMLSelectNodes($text & "/" & $node & "/" & $propertie)
;~ 	ConsoleWrite("Error SelectNode: " & _XMLError() & @LF)
;~ 	_ArrayDisplay($array, 5)
;~ 	$array = _XMLGetField("object/properties"); genau das gleiche wie _XMLGetValue
;~ 	$array = _XMLGetValue('object/properties/property name="Left"'); funktioniert nicht
;~ 	$array = _XMLGetAttrib("object/properties/property", 'name="Left"'); -> hat keine Attributes
;~ 	$array = _XMLGetAttrib("object/properties", $a1, $a2); -> hat keine Attributes
;~ 	$array = _XMLGetAllAttrib("object/properties", $a1, $a2); -> hat keine Attributes
;~ 	$array = _XMLGetAllAttrib("object/properties/property", $a1, $a2); -> liest nur das letzte Property aus
;~ 	$array = _XMLGetAllAttrib("object/properties/property", $a1, $a2); -> Bekomme ich nur das Letzte property ausgelesen, nicht die davor.
;~ 	ConsoleWrite("Error GetAllAttrib: " & _XMLError() & @LF)
;~ 	_ArrayDisplay($array, 6)
;~ 	_ArrayDisplay($a1, 6.1)
;~ 	_ArrayDisplay($a2, 6.2)

;~ 	_XMLSetAttrib("object/properties", "Left", "TestLeft"); -> Setzt ein <properties Left="TestLeft">
;~ 	_XMLSetAttrib("object/properties/property", "name", "TestLeft"); -> Setzt (leider) alle auf <property name="TestLeft"
	#ce
EndFunc   ;==>_KodaReadFileToArray



Func _KodaSetStruct()
	#cs=========================================================
		;   Create the Window
		;   struct {
		;
		;       int			posx		Left
		;       int			posy		Top
		;       int			width		Width
		;       int			height		Height
		;		wchar		caption		Caption
		;		wchar		bkcolor		Color
		;								Font.Charset
		;		wchar		fontcolor	Font.Color
		;		int			fontheight	Font.Height
		;		wchar		fontname	Font.Name
		;		wchar		fontstyle	Font.Style
		;								OldCreateOrder
		;		boolean		visible		Visible
		;		int			style		Style
		;		int			exstyle		Style Extended
		;		wchar		version		Version (?)
		;		boolean		OPTonevent	FormOptOnEvent
		;		boolean					FormOptExpVars
		;		boolean					FormOptPopulate
		;		boolean					FormOptVarsForSet
		;		boolean					FormOptIndentChar
		;		boolean					FormOptIndentCount
		;		boolean					FormOptIndentInit
		;		boolean					FormOptVarScope
		;		wchar		resizing	Resizing
		;
		;
		;		bkcolor muss als Hex dargstellt werden. String in Hex umwandeln, dann verwenden.
		;		fontcolor muss als Hex dargestellt werden. String in Hex umwandeln
		;		fontstyle muss als INT dargestellt werden. String in INT umwandeln
		;
		;
		;
		; }
	#ce =========================================================
	Local $var
	For $i = 1 To UBound($aKodaGuiAttributes) - 1 Step 1
		If $aKodaGuiAttributes[$i][1] = "name" Then
			$var = $aKodaGuiValues[$aKodaGuiAttributes[$i][0]][1]
			Switch $aKodaGuiAttributes[$i][2]
				Case "Left";
					DllStructSetData($Struct, "posx", $var)
				Case "Top";
					DllStructSetData($Struct, "posy", $var)
				Case "Width";
					DllStructSetData($Struct, "width", $var)
				Case "Height";
					DllStructSetData($Struct, "height", $var)
				Case "Caption";
					DllStructSetData($Struct, "caption", $var)
				Case "Color";
					DllStructSetData($Struct, "bkcolor", _KodaGetHexColor($var))
				Case "Font.Charset";
					DllStructSetData($Struct, "", $var)
				Case "Font.Color";
					DllStructSetData($Struct, "fontcolor", $var)
				Case "Font.Height";
					DllStructSetData($Struct, "fontheight", $var)
				Case "Font.Name";
					DllStructSetData($Struct, "fontname", $var)
				Case "Font.Style";
					DllStructSetData($Struct, "fontstyle", $var)
				Case "OldCreateOrder";
					DllStructSetData($Struct, "", $var)
				Case "Visible";
					DllStructSetData($Struct, "visible", $var)
				Case "ParentForm";
					DllStructSetData($Struct, "parent", $var)
				Case "Style";
					DllStructSetData($Struct, "style", $var)
				Case "ExStyle";
					DllStructSetData($Struct, "exstyle", $var)
				Case "Version";
					DllStructSetData($Struct, "version", $var)
				Case "OnMinimize";
					DllStructSetData($Struct, "", $var)
				Case "OnMaximize";
					DllStructSetData($Struct, "", $var)
				Case "OnRestore";
					DllStructSetData($Struct, "", $var)
				Case "FormOptOnEvent";
					DllStructSetData($Struct, "OPTonevent", $var)
				Case "FormOptExpVars";
					DllStructSetData($Struct, "", $var)
				Case "FormOptPopulate";
					DllStructSetData($Struct, "", $var)
				Case "FormOptVarsForSet";
					DllStructSetData($Struct, "", $var)
				Case "FormOptIndentChar";
					DllStructSetData($Struct, "", $var)
				Case "FormOptIndentCount";
					DllStructSetData($Struct, "", $var)
				Case "FormOptIndentInit";
					DllStructSetData($Struct, "", $var)
				Case "FormOptVarScope";
					DllStructSetData($Struct, "optvarscope", _KodaGetOptVarScope($var))
				Case "Resizing";
					DllStructSetData($Struct, "resizing", $var)
				Case "PixelsPerInch";
					DllStructSetData($Struct, "", $var)
				Case "TextHeight";
					DllStructSetData($Struct, "", $var)
				Case Else
					ConsoleWrite("Not supported Format: " & $aKodaGuiAttributes[$i][2] & @LF)
					MsgBox(64, "Error....", "Not supported Format: " & $aKodaGuiAttributes[$i][2] & @LF & "Value: " & _
							$var)
			EndSwitch
;~ 			Switch @error
;~ 			Case 2
;~ 				MsgBox("","","Fehler mit DllSctructSetData einfgen. Manche werden vllt im ISN nicht bentigt, " & _
;~ 					"dazu keinen Fehler generieren, oder gar nicht benutzen")
;~ 			EndSwitch
		EndIf
	Next
EndFunc   ;==>_KodaSetStruct

Func _KodaGetOptVarScope($var)
	Local $ret = 0
	Switch $var
		Case 0
			$ret = 0
		Case 1
			$ret = "global"
			Case 2
			$ret = "local"
			Case Else
			$ret = 0
	EndSwitch
	Return $ret
EndFunc


Func _KodaGetHexColor($var)
	Local $ret = "0x"
	Switch $var
		Case "clBlack"
			$ret = "0x000000"
		Case "clMaroon"
			$ret = "0x800000"
		Case "clGreen"
			$ret = "0x008000"
		Case "clOlive"
			$ret = "0x808000"
		Case "clNavy"
			$ret = "0x000080"
		Case "clPurple"
			$ret = "0x800080"
		Case "clTeal"
			$ret = "0x008080"
		Case "clGray"
			$ret = "0x808080"
		Case "clSilver"
			$ret = "0xC0C0C0"
		Case "clRed"
			$ret = "0xFF0000"
		Case "clLime"
			$ret = "0x00FF00"
		Case "clYellow"
			$ret = "0xFFFF00"
		Case "clBlue"
			$ret = "0x0000FF"
		Case "clFuchsia"
			$ret = "0xFF00FF"
		Case "clAqua"
			$ret = "0x00FFFF"
		Case "clWhite"
			$ret = "0xFFFFFF"
		Case "clMoneyGreen"
			$ret = "0xC0DCC0"
		Case "clSkyBlue"
			$ret = "0xA6CAF0"
		Case "clCream"
			$ret = "0xFFFBF0"
		Case "clMedGray"
			$ret = "0xA0A0A4"
		Case "clActiveBorder"
			;_WinAPI_GetSysColor($COLOR_ACTIVEBORDER)
			$ret = _WinAPI_GetSysColor($COLOR_ACTIVEBORDER)
		Case "clActiveCaption"
			;_WinAPI_GetSysColor($COLOR_ACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_ACTIVECAPTION)
		Case "clAppWorkSpace"
			;_WinAPI_GetSysColor($COLOR_APPWORKSPACE)
			$ret = _WinAPI_GetSysColor($COLOR_APPWORKSPACE)
		Case "clBackground"
			;_WinAPI_GetSysColor($COLOR_BACKGROUND)
			$ret = _WinAPI_GetSysColor($COLOR_BACKGROUND)
		Case "clBtnFace"
			;_WinAPI_GetSysColor($COLOR_BTNFACE)
			$ret = _WinAPI_GetSysColor($COLOR_BTNFACE)
		Case "clBtnHighlight"
			;_WinAPI_GetSysColor($COLOR_BTNHIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_BTNHIGHLIGHT)
		Case "clBtnShadow"
			;_WinAPI_GetSysColor($COLOR_BTNSHADOW)
			$ret = _WinAPI_GetSysColor($COLOR_BTNSHADOW)
		Case "clBtnText"
			;_WinAPI_GetSysColor($COLOR_BTNTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_BTNTEXT)
		Case "clCaptionText"
			;_WinAPI_GetSysColor($COLOR_CAPTIONTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_CAPTIONTEXT)
		Case "clGradientActiveCaption"
			;_WinAPI_GetSysColor($COLOR_GRADIENTACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_GRADIENTACTIVECAPTION)
		Case "clGradientInactiveCaption"
			;_WinAPI_GetSysColor($COLOR_GRADIENTINACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_GRADIENTINACTIVECAPTION)
		Case "clGrayText"
			;_WinAPI_GetSysColor($COLOR_GRAYTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_GRAYTEXT)
		Case "clHighlight"
			;_WinAPI_GetSysColor($COLOR_HIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_HIGHLIGHT)
		Case "clHighlightText"
			;_WinAPI_GetSysColor($COLOR_HIGHLIGHTTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_HIGHLIGHTTEXT)
		Case "clHotlight"
			;_WinAPI_GetSysColor($COLOR_HOTLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_HOTLIGHT)
		Case "clInactiveBorder"
			;_WinAPI_GetSysColor($COLOR_INACTIVEBORDER)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVEBORDER)
		Case "clInactiveCaption"
			;_WinAPI_GetSysColor($COLOR_INACTIVECAPTION)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVECAPTION)
		Case "clInactiveCaptionText"
			;_WinAPI_GetSysColor($COLOR_INACTIVECAPTIONTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_INACTIVECAPTIONTEXT)
		Case "clInfoBK"
			;_WinAPI_GetSysColor($COLOR_INFOBK)
			$ret = _WinAPI_GetSysColor($COLOR_INFOBK)
		Case "clInfoText"
			;_WinAPI_GetSysColor($COLOR_INFOTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_INFOTEXT)
		Case "clMenu"
			;_WinAPI_GetSysColor($COLOR_MENU)
			$ret = _WinAPI_GetSysColor($COLOR_MENU)
		Case "clMenuBar"
			;_WinAPI_GetSysColor($COLOR_MENUBAR)
			$ret = _WinAPI_GetSysColor($COLOR_MENUBAR)
		Case "clMenuHighlight"
			;_WinAPI_GetSysColor($COLOR_MENUHIGHLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_MENUHIGHLIGHT)
		Case "clMenuText"
			;_WinAPI_GetSysColor($COLOR_MENUTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_MENUTEXT)
		Case "clScrollbar"
			;_WinAPI_GetSysColor($COLOR_SCROLLBAR)
			$ret = _WinAPI_GetSysColor($COLOR_SCROLLBAR)
		Case "cl3DDkShadow"
			;_WinAPI_GetSysColor($COLOR_3DDKSGADOW)
			$ret = _WinAPI_GetSysColor($COLOR_3DDKSGADOW)
		Case "cl3DLight"
			;_WinAPI_GetSysColor($COLOR_3DLIGHT)
			$ret = _WinAPI_GetSysColor($COLOR_3DLIGHT)
		Case "clWindow"
			;_WinAPI_GetSysColor($COLOR_WINDOW)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOW)
		Case "clWindowFrame"
			;_WinAPI_GetSysColor($COLOR_WINDOWFRAME)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOWFRAME)
		Case "clWindowText"
			;_WinAPI_GetSysColor($COLOR_WINDOWTEXT)
			$ret = _WinAPI_GetSysColor($COLOR_WINDOWTEXT)
		Case Else
			ConsoleWrite("Not supported Format: " & $var & @LF)
			
			; andere Formate knnen mit _WinAPI_GetSysColor(IDENT) ausgelesen werden. Problem: ist iin KODA nur mit der lokalen Einstellung abzuspeichern, wenn ein Code generiert wird.
	EndSwitch
	
	Return $ret
EndFunc


